/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20200430 (64-bit version)
 * Copyright (c) 2000 - 2020 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT10.aml, Fri May 22 18:22:26 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000260 (608)
 *     Revision         0x02
 *     Checksum         0x62
 *     OEM ID           "HP    "
 *     OEM Table ID     "PwrCtlEv"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20121018 (538054680)
 */
DefinitionBlock ("", "SSDT", 2, "HP    ", "PwrCtlEv", 0x00000001)
{
    External (_SB_.PCI0.LPCB.EC0_, DeviceObj)
    External (_SB_.PCI0.LPCB.EC0_.ECMX, MutexObj)
    External (_SB_.PCI0.LPCB.EC0_.ECRG, IntObj)
    External (_SB_.PCI0.LPCB.EC0_.PSSB, FieldUnitObj)
    External (_SB_.WMIV.GVWE, MethodObj)    // 2 Arguments

    Scope (\_SB.PCI0.LPCB.EC0)
    {
        OperationRegion (HPSF, SystemMemory, 0x81E6B000, 0x00000003)
        Field (HPSF, AnyAcc, Lock, Preserve)
        {
            PSCF,   8, 
            BCIF,   8, 
            BCSC,   8
        }

        Name (PSSS, Zero)
        Method (_Q20, 0, NotSerialized)  // _Qxx: EC Query, xx=0x00-0xFF
        {
            Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
            If (ECRG)
            {
                Store (And (PSSS, One), Local0)
                Store (And (\_SB.PCI0.LPCB.EC0.PSSB, One), Local1)
                Store (And (PSSS, 0x02), Local2)
                Store (And (\_SB.PCI0.LPCB.EC0.PSSB, 0x02), Local3)
                Store (And (PSSS, 0x10), Local4)
                Store (And (\_SB.PCI0.LPCB.EC0.PSSB, 0x10), Local5)
                If (LAnd (LNotEqual (Local0, Local1), LEqual (Local0, Zero)))
                {
                    \_SB.WMIV.GVWE (0x0F, Zero)
                    Store (\_SB.PCI0.LPCB.EC0.PSSB, PSSS) /* \_SB_.PCI0.LPCB.EC0_.PSSS */
                }
                ElseIf (LAnd (LNotEqual (Local4, Local5), LEqual (Local4, Zero)))
                {
                    \_SB.WMIV.GVWE (0x0F, 0x03)
                    Store (\_SB.PCI0.LPCB.EC0.PSSB, PSSS) /* \_SB_.PCI0.LPCB.EC0_.PSSS */
                }
                ElseIf (LAnd (LNotEqual (Local0, Local1), LEqual (Local0, One)))
                {
                    \_SB.WMIV.GVWE (0x0F, One)
                    Store (\_SB.PCI0.LPCB.EC0.PSSB, PSSS) /* \_SB_.PCI0.LPCB.EC0_.PSSS */
                }
                ElseIf (LAnd (LNotEqual (Local2, Local3), LEqual (Local2, 0x02)))
                {
                    If (LNot (BCIF))
                    {
                        \_SB.WMIV.GVWE (0x10, Zero)
                    }

                    Store (Zero, BCIF) /* \_SB_.PCI0.LPCB.EC0_.BCIF */
                    Store (\_SB.PCI0.LPCB.EC0.PSSB, PSSS) /* \_SB_.PCI0.LPCB.EC0_.PSSS */
                }
                ElseIf (LAnd (LNotEqual (Local2, Local3), LEqual (Local2, Zero)))
                {
                    If (LNot (BCIF))
                    {
                        \_SB.WMIV.GVWE (0x10, One)
                    }

                    Store (Zero, BCIF) /* \_SB_.PCI0.LPCB.EC0_.BCIF */
                    Store (\_SB.PCI0.LPCB.EC0.PSSB, PSSS) /* \_SB_.PCI0.LPCB.EC0_.PSSS */
                }
            }

            Release (\_SB.PCI0.LPCB.EC0.ECMX)
        }
    }
}

