/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20200430 (64-bit version)
 * Copyright (c) 2000 - 2020 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT7.aml, Fri May 22 18:22:26 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000059F (1439)
 *     Revision         0x02
 *     Checksum         0x70
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "SDS_RTD3"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20121018 (538054680)
 */
DefinitionBlock ("", "SSDT", 2, "HPQOEM", "SDS_RTD3", 0x00001000)
{
    /*
     * iASL Warning: There was 1 external control method found during
     * disassembly, but only 0 were resolved (1 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.GGOV, UnknownObj)
    External (_SB_.PCI0.XHC_, DeviceObj)
    External (_SB_.PCI0.XHC_.HP01, UnknownObj)
    External (_SB_.PCI0.XHC_.HP02, UnknownObj)
    External (_SB_.PCI0.XHC_.HP03, UnknownObj)
    External (_SB_.PCI0.XHC_.HP05, UnknownObj)
    External (_SB_.PCI0.XHC_.HP07, UnknownObj)
    External (_SB_.PCI0.XHC_.HP09, UnknownObj)
    External (_SB_.PCI0.XHC_.RHUB, DeviceObj)
    External (_SB_.PCI0.XHC_.RHUB.HS02, DeviceObj)
    External (_SB_.PCI0.XHC_.RHUB.HS03, DeviceObj)
    External (_SB_.PCI0.XHC_.XHCV, UnknownObj)
    External (_SB_.SGOV, MethodObj)    // Warning: Unknown method, guessing 2 arguments

    Scope (\_SB.PCI0.XHC)
    {
        Name (UPWR, Zero)
        Name (USPP, Zero)
    }

    Scope (\_SB.PCI0.XHC.RHUB)
    {
        Name (HS1C, Zero)
        Name (HS2C, Zero)
        Name (HS3C, Zero)
        Name (HS5C, Zero)
        Name (HS7C, Zero)
        Name (HS9C, Zero)
        Method (PS0X, 0, Serialized)
        {
            Store (Zero, \_SB.PCI0.XHC.USPP)
        }

        Method (PS2X, 0, Serialized)
        {
            If (LEqual (\_SB.PCI0.XHC.XHCV, 0xFFFF))
            {
                Return (Zero)
            }

            If (LEqual (\_SB.PCI0.XHC.HP01, Zero))
            {
                Or (\_SB.PCI0.XHC.USPP, One, \_SB.PCI0.XHC.USPP)
            }

            If (LEqual (\_SB.PCI0.XHC.HP02, Zero))
            {
                Or (\_SB.PCI0.XHC.USPP, 0x02, \_SB.PCI0.XHC.USPP)
            }

            If (LEqual (\_SB.PCI0.XHC.HP03, Zero))
            {
                Or (\_SB.PCI0.XHC.USPP, 0x04, \_SB.PCI0.XHC.USPP)
            }

            If (LEqual (\_SB.PCI0.XHC.HP05, Zero))
            {
                Or (\_SB.PCI0.XHC.USPP, 0x08, \_SB.PCI0.XHC.USPP)
            }

            If (LEqual (\_SB.PCI0.XHC.HP07, Zero))
            {
                Or (\_SB.PCI0.XHC.USPP, 0x10, \_SB.PCI0.XHC.USPP)
            }

            If (LEqual (\_SB.PCI0.XHC.HP09, Zero))
            {
                Or (\_SB.PCI0.XHC.USPP, 0x20, \_SB.PCI0.XHC.USPP)
            }
        }

        Method (PS3X, 0, Serialized)
        {
        }

        Method (INIR, 0, Serialized)
        {
            If (LEqual (\_SB.PCI0.XHC.XHCV, 0xFFFF))
            {
                Return (Zero)
            }

            If (LEqual (\_SB.PCI0.XHC.HP01, One))
            {
                Store (One, HS1C) /* \_SB_.PCI0.XHC_.RHUB.HS1C */
            }

            If (LEqual (\_SB.PCI0.XHC.HP02, One))
            {
                Store (One, HS2C) /* \_SB_.PCI0.XHC_.RHUB.HS2C */
            }

            If (LEqual (\_SB.PCI0.XHC.HP03, One))
            {
                Store (One, HS3C) /* \_SB_.PCI0.XHC_.RHUB.HS3C */
            }

            If (LEqual (\_SB.PCI0.XHC.HP05, One))
            {
                Store (One, HS5C) /* \_SB_.PCI0.XHC_.RHUB.HS5C */
            }

            If (LEqual (\_SB.PCI0.XHC.HP07, One))
            {
                Store (One, HS7C) /* \_SB_.PCI0.XHC_.RHUB.HS7C */
            }

            If (LEqual (\_SB.PCI0.XHC.HP09, One))
            {
                Store (One, HS9C) /* \_SB_.PCI0.XHC_.RHUB.HS9C */
            }
        }

        PowerResource (PRFP, 0x00, 0x0000)
        {
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (LEqual (\_SB.GGOV, 0x02020014))
                {
                    One
                    Return (Zero)
                }
                Else
                {
                    Return (One)
                }
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                \_SB.SGOV (0x02020014, 0xFFFFFFFFFFFFFFFE)
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                \_SB.SGOV (0x02020014, One)
            }
        }

        PowerResource (PRFC, 0x00, 0x0000)
        {
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (LEqual (\_SB.GGOV, 0x02010013))
                {
                    One
                    Return (One)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                \_SB.SGOV (0x02010013, One)
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                \_SB.SGOV (0x02010013, 0xFFFFFFFFFFFFFFFE)
            }
        }
    }

    Scope (\_SB.PCI0.XHC.RHUB.HS02)
    {
        Method (_PR0, 0, NotSerialized)  // _PR0: Power Resources for D0
        {
            If (LEqual (\_SB.PCI0.XHC.RHUB.HS2C, One))
            {
                Return (Package (0x01)
                {
                    \_SB.PCI0.XHC.RHUB.PRFP
                })
            }
            Else
            {
                Return (Package (0x00){})
            }
        }

        Method (_PR2, 0, NotSerialized)  // _PR2: Power Resources for D2
        {
            If (LEqual (\_SB.PCI0.XHC.RHUB.HS2C, One))
            {
                Return (Package (0x01)
                {
                    \_SB.PCI0.XHC.RHUB.PRFP
                })
            }
            Else
            {
                Return (Package (0x00){})
            }
        }

        Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
        {
            If (LEqual (\_SB.PCI0.XHC.RHUB.HS2C, One))
            {
                Return (Package (0x01)
                {
                    \_SB.PCI0.XHC.RHUB.PRFP
                })
            }
            Else
            {
                Return (Package (0x00){})
            }
        }
    }

    Scope (\_SB.PCI0.XHC.RHUB.HS03)
    {
        Method (_PR0, 0, NotSerialized)  // _PR0: Power Resources for D0
        {
            If (LEqual (\_SB.PCI0.XHC.RHUB.HS3C, One))
            {
                Return (Package (0x01)
                {
                    \_SB.PCI0.XHC.RHUB.PRFC
                })
            }
            Else
            {
                Return (Package (0x00){})
            }
        }

        Method (_PR2, 0, NotSerialized)  // _PR2: Power Resources for D2
        {
            If (LEqual (\_SB.PCI0.XHC.RHUB.HS3C, One))
            {
                Return (Package (0x01)
                {
                    \_SB.PCI0.XHC.RHUB.PRFC
                })
            }
            Else
            {
                Return (Package (0x00){})
            }
        }

        Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
        {
            If (LEqual (\_SB.PCI0.XHC.RHUB.HS3C, One))
            {
                Return (Package (0x01)
                {
                    \_SB.PCI0.XHC.RHUB.PRFC
                })
            }
            Else
            {
                Return (Package (0x00){})
            }
        }
    }
}

